#include<iostream.h>
#include<iomanip.h>
#include<conio.h>
#include<ctype.h>
#include<fstream.h>
#include<stdlib.h>


typedef int type_elt;
#include"liste_fc.h"

// prototype des fonctions

void afficher_elem_liste(liste L);
void afficher_liste(liste L);
liste saisir_liste(void);
int est_present(type_elt x, liste L);
liste recopier(liste L1);
void ajouter_en_fin(type_elt x, liste & L);
void ajouter_trie(type_elt x, liste & L);
void supprimer_en_tete(liste &L);
void supprimer_les_occurences(type_elt x, liste &L);

liste concatener(liste L1, liste L2);
int est_un_ens(liste L);
liste creer_ens(liste L);       		// une nouvelle liste est cree
void transformer_en_ens(liste & L);		// L est modifiee
liste intersection(liste LE1, liste LE2);
liste union_ens(liste LE1, liste LE2);
int meme_ens(liste LE1, liste LE2);
int est_inclus(liste LE1, liste LE2);

///////////////////////////////////// main ///////////////////

void main(void) {
liste L,L1,L2,LE;
	// tester ici les nouvelles fonctions ajoutees
L1=saisir_liste();
L2=saisir_liste();

L = concatener(L1,L2);
cout << "concatenation : ";
afficher_liste(L);

cout << "L est un ens : " << est_un_ens(L) << endl;

LE = creer_ens(L);
afficher_liste(LE);

L1 = creer_ens(L1);		// l'anc liste L1 est perdue ds la nature!
L2 = creer_ens(L2);

L = intersection(L1, L2);

cout << "inter ";
afficher_liste(L);

L = union_ens(L1,L2);

cout << "union ";
afficher_liste(L);

cout << "L1 est inclus ds L2 :" << est_inclus(L1,L2);

}

/////////////// Definitions des fonctions /////////////////////:
void afficher_elem_liste(liste L) {
  if (L!=liste_vide) {
     cout << tete(L);
     if (reste(L) != liste_vide)
	  cout << ", ";
     afficher_elem_liste(reste(L));
  }
}

void afficher_liste(liste L) {
cout << "(";
afficher_elem_liste(L);
cout << ")";
cout << endl;
}

liste saisir_liste(void) {
 char un_autre='o';
 type_elt e;
 liste L;
 L = liste_vide;

 cout << "entrez un element ? (o/n) ";
 cin >> un_autre;
 if (un_autre=='o' || un_autre == 'O') {
    cin >> e;
    L=saisir_liste();		// on saisit le reste
    ajouter_en_tete(e,L);
 }
 return L;
}

int est_present(type_elt x, liste L) {
  if (L == liste_vide) return 0;
  if (x == tete(L)) return 1;
  return est_present(x,reste(L));
}

liste recopier(liste L1) {
 liste L2 = liste_vide;
 if (L1 != liste_vide) {
    L2 = recopier(reste(L1));
    ajouter_en_tete(tete(L1),L2);
 }
 return L2;
}

void ajouter_en_fin(type_elt x, liste & L) {
 if (L == liste_vide)
	ajouter_en_tete(x,L);
 else
	ajouter_en_fin(x,L->suiv);	// pb avec reste(L) car != left-value
}

void ajouter_trie(type_elt x, liste & L) {
 if (L==liste_vide || x <= tete(L))
	ajouter_en_tete(x,L);
 else
	ajouter_trie(x,L->suiv);		// pb car reste(L) ! left-value
}

void supprimer_en_tete(liste & L) {
 liste tempo;
 if (L!=liste_vide) {
    tempo = L;
    L = reste(L);
    delete tempo;
 }
}

void supprimer_les_occurences(type_elt x, liste & L) {	// toutes les occur.
 if (L != liste_vide) {
    if (x==tete(L)) {
	 supprimer_en_tete(L);
	 supprimer_les_occurences(x,L);
    }
    else
	 supprimer_les_occurences(x,L->suiv);
 }
}

/////////// LISTES REPRESENTANT DES ENSEMBLES //////////

liste concatener(liste L1, liste L2) {
 liste L3;
 if (L1 == liste_vide) return recopier(L2);
 L3 = concatener(reste(L1), L2);
 ajouter_en_tete(tete(L1), L3);
 return L3;
}

int est_un_ens(liste L) {
 if (L == liste_vide) return 0;
 if (est_present(tete(L),reste(L))) return 0;
 return est_un_ens(reste(L));
}

liste creer_ens(liste L) {
 liste LE;
 if (L == liste_vide) return liste_vide;
 LE = creer_ens(reste(L));
 if (!est_present(tete(L), reste(L)))
    ajouter_en_tete(tete(L), LE);    	// LE est modifie
 return LE;
}

void transformer_en_ens(liste & L) {
 if (L != liste_vide) {
     if (est_present(tete(L),reste(L)))
	  supprimer_en_tete(L);
     else
	  transformer_en_ens(L->suiv);
 }
}

liste intersection(liste LE1, liste LE2) {	// LE1 et LE2 sont des ens.
 liste LEinter;
 if (LE1 == liste_vide) return liste_vide;
 LEinter = intersection(reste(LE1), LE2);
 if (est_present(tete(LE1),LE2))
    ajouter_en_tete(tete(LE1),LEinter);	// LEinter est modifie
 return LEinter;
}

liste union_ens(liste LE1, liste LE2) {
 liste L;
 L = concatener(LE1,LE2);
 transformer_en_ens(L);
 return L;
}

int meme_ens(liste LE1, liste LE2) {
 return (est_inclus(LE1,LE2) && est_inclus(LE2,LE1));
}

int est_inclus(liste LE1, liste LE2) {
 if (LE1 == liste_vide) return 1;
 return (est_present(tete(LE1),LE2) && est_inclus(reste(LE1),LE2));
}


